-- TP1
DROP TABLE INSTALLER;
DROP TABLE POSTE;
DROP TABLE LOGICIEL;
DROP TABLE SALLE;
DROP TABLE SEGMENT;
CREATE TABLE SEGMENT
	(N_SEGMENT VARCHAR(10),
	 NOM_SEGMENT VARCHAR(20),
	 CONSTRAINT PK_SEGMENT PRIMARY KEY(N_SEGMENT)
	);
CREATE TABLE SALLE
	(N_SALLE VARCHAR(7),
	 NOM_S VARCHAR(20),
	 NB_POSTE NUMBER(3),
 	 N_SEGMENT VARCHAR(10),
	 CONSTRAINT PK_SALLE PRIMARY KEY(N_SALLE),
	 CONSTRAINT FK_SALLE_SEGMENT FOREIGN KEY(N_SEGMENT)
	 REFERENCES SEGMENT(N_SEGMENT)
);
--CREATE INDEX IND_SALLE_SEGMENT ON SALLE(N_SEGMENT);
CREATE TABLE LOGICIEL
	(N_LOG VARCHAR(5),
	 NOM_L VARCHAR(20),
	 DATE_ACH DATE,
	 VERSION VARCHAR(7),
	 TYPE_L VARCHAR(6),
	 CONSTRAINT PK_LOGICIEL PRIMARY KEY(N_LOG)
	);
CREATE TABLE POSTE
	(N_POSTE VARCHAR(7),
	 NOM_P VARCHAR(20),
	 N_SEGMENT VARCHAR(10)
	 CONSTRAINT NN_POSTE_N_SEGMENT NOT NULL,
	 AD VARCHAR(2),
	 TYPE_P VARCHAR(6),
	 N_SALLE VARCHAR(7)
	 CONSTRAINT NN_POSTE_N_SALLE NOT NULL,
	 CONSTRAINT PK_POSTE PRIMARY KEY(N_POSTE),
	 CONSTRAINT FK_POSTE_SALLE FOREIGN KEY(N_SALLE)
	 REFERENCES SALLE(N_SALLE),
	 CONSTRAINT FK_POSTE_SEGMENT FOREIGN KEY(N_SEGMENT)
	 REFERENCES SEGMENT(N_SEGMENT),
	 CONSTRAINT UN_POSTE_AD_N_SEGMENT UNIQUE(N_SEGMENT,AD)
	);
--CREATE INDEX IND_POSTE_SALLE ON POSTE(N_SALLE);
--CREATE INDEX IND_POSTE_SEGMENT ON POSTE(N_SEGMENT);
CREATE TABLE INSTALLER
	(N_POSTE VARCHAR(7),
	 N_LOG VARCHAR(5),
	 DATE_INS DATE,
	 CONSTRAINT PK_INSTALLER PRIMARY KEY(N_POSTE,N_LOG),
	 CONSTRAINT FK_INSTALLER_POSTE FOREIGN KEY(N_POSTE)
	 REFERENCES POSTE(N_POSTE),
	 CONSTRAINT FK_INSTALLER_LOGICIEL FOREIGN KEY(N_LOG)
	 REFERENCES LOGICIEL(N_LOG)
	);
--CREATE INDEX IND_INSTALLER_LOGICIEL ON INSTALLER(N_LOG);

DELETE FROM installer;
DELETE FROM poste;
DELETE FROM salle;
DELETE FROM segment;
DELETE FROM logiciel;

INSERT INTO segment(n_segment,nom_segment) VALUES
('130.120.80','segment 80');
INSERT INTO segment(n_segment,nom_segment) VALUES
('130.120.81','segment 81');
INSERT INTO segment(n_segment,nom_segment) VALUES
('130.120.82','segment 82');
INSERT INTO salle(n_salle,nom_s,nb_poste,n_segment) VALUES
('s01','Salle 1',3,'130.120.80');
INSERT INTO salle(n_salle,nom_s,nb_poste,n_segment) VALUES
('s02','Salle 2',2,'130.120.80');
INSERT INTO salle(n_salle,nom_s,nb_poste,n_segment) VALUES
('s03','Salle 3',2,'130.120.80');
INSERT INTO salle(n_salle,nom_s,nb_poste,n_segment) VALUES
('s11','Salle 11',2,'130.120.81');
INSERT INTO salle(n_salle,nom_s,nb_poste,n_segment) VALUES
('s12','Salle 12',1,'130.120.81');
INSERT INTO salle(n_salle,nom_s,nb_poste,n_segment) VALUES
('s21','Salle 21',2,'130.120.82');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p1','Poste 1','130.120.80','01','TX','s01');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p2','Poste 2','130.120.80','02','UNIX','s01');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p3','Poste 3','130.120.80','03','TX','s01');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p4','Poste 4','130.120.80','04','PCWS','s02');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p5','Poste 5','130.120.80','05','PCWS','s02');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p6','Poste 6','130.120.80','06','UNIX','s03');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p7','Poste 7','130.120.80','07','TX','s03');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p8','Poste 8','130.120.81','01','UNIX','s11');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p9','Poste 9','130.120.81','02','TX','s11');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p10','Poste 10','130.120.81','03','UNIX','s12');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p11','Poste 11','130.120.82','01','PCNT','s21');
INSERT INTO poste(n_poste,nom_p,n_segment,ad,type_p,n_salle) VALUES
('p12','Poste 12','130.120.82','02','PCWS','s21');
INSERT INTO logiciel(n_log,nom_l,date_ach,version,type_l) VALUES
('log1','Oracle 7','13-MAY-1999','7.3.2','UNIX');
INSERT INTO logiciel(n_log,nom_l,date_ach,version,type_l) VALUES
('log2','Oracle 8','15-SEP-1999','8.0','UNIX');
INSERT INTO logiciel(n_log,nom_l,date_ach,version,type_l) VALUES
('log3','Sql server','12-APR-1999','7','PCNT');
INSERT INTO logiciel(n_log,nom_l,date_ach,version,type_l) VALUES
('log4','Front Page','3-JUN-1999','5','PCWS');
INSERT INTO logiciel(n_log,nom_l,date_ach,version,type_l) VALUES
('log5','WinDev','12-MAY-1999','5','PCWS');
INSERT INTO logiciel(n_log,nom_l,date_ach,version,type_l) VALUES
('log6','Sql*Net','13-MAY-1999','2.0','UNIX');
INSERT INTO logiciel(n_log,nom_l,date_ach,version,type_l) VALUES
('log7','I. I. S.','12-APR-1999','2','PCNT');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p2','log1','15-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p2','log2','17-SEP-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p4','log5','30-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p6','log6','20-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p6','log1','20-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p8','log2','19-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p8','log6','20-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p11','log3','20-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p12','log4','20-MAY-1999');
INSERT INTO installer(n_poste,n_log,date_ins) VALUES
('p11','log7','20-APR-1999');
COMMIT;

--TP2

ALTER TABLE segment ADD(etage NUMBER(2),nb_salle NUMBER(2),nb_poste NUMBER(2));
ALTER TABLE logiciel ADD(nb_install NUMBER(2));
ALTER TABLE poste ADD(nb_log NUMBER(2));

DROP TABLE type;
CREATE TABLE type
(typ_lp VARCHAR(6),
nom_type VARCHAR(20),
CONSTRAINT pk_type PRIMARY KEY(typ_lp)
);

ALTER TABLE salle MODIFY(nom_s VARCHAR(30));
INSERT INTO type VALUES ('TX','Terminal X-WINDOW');
INSERT INTO type VALUES ('UNIX','Systeme UNIX');
INSERT INTO type VALUES ('PCNT','PC Windows NT');
INSERT INTO type VALUES ('PCWS','PC Windows 95');
INSERT INTO type VALUES ('NC','Network Computer');
COMMIT;
UPDATE segment  SET etage=0 WHERE n_segment LIKE  '%80';
UPDATE segment  SET etage=1 WHERE n_segment LIKE  '%81';
UPDATE segment  SET etage=2 WHERE n_segment LIKE  '%82';
COMMIT;
ALTER TABLE poste ADD CONSTRAINT fk_poste_type FOREIGN KEY(type_p) REFERENCES type(TYP_LP);
ALTER TABLE logiciel ADD CONSTRAINT fk_logiciel_type FOREIGN KEY(type_l) REFERENCES type(TYP_LP);
ALTER TABLE poste MODIFY (type_p VARCHAR(6) CONSTRAINT nn_poste_type_p NOT NULL);
ALTER TABLE logiciel MODIFY (type_l VARCHAR(6) CONSTRAINT nn_logiciel_type_l NOT NULL);



INSERT INTO installer (n_poste,n_log)
  VALUES ('p2','log6');
INSERT INTO installer (n_poste,n_log)
  VALUES ('p8','log1');
INSERT INTO installer (n_poste,n_log)
  VALUES ('p10','log1');
  

UPDATE segment seg
SET nb_salle=
  (SELECT COUNT(*) FROM salle s
    WHERE seg.n_segment=s.n_segment);
  
UPDATE segment seg
SET nb_poste=
  (SELECT COUNT (*) FROM poste p
    WHERE seg.n_segment=p.n_segment);
    
UPDATE logiciel log
SET nb_install=
  (SELECT COUNT(*) FROM installer ins
    WHERE log.n_log=ins.n_log);
  
UPDATE poste p
SET nb_log=
  (SELECT COUNT(*) FROM installer ins
    WHERE p.n_poste=ins.n_poste);
    
alter table type add tarif number (3);
update type set tarif=50 where typ_lp='TX';
update type set tarif=100 where typ_lp='PCWS';
update type set tarif=120 where typ_lp='PCNT';
update type set tarif=200 where typ_lp='UNIX';
update type set tarif=80 where typ_lp='NC';
    
COMMIT;



