SHELL=/bin/sh
AS_EXT=s
LIB_EXT=a
OBJ_EXT=o
PLB_EXT=plb
SO_EXT=sl
LOCK_EXT=lk
SQL_EXT=sql
AR=ar
AS=as
AWK=awk
CAT=cat
CC=cc
CD=cd
CHMOD=chmod
CP=cp
CPP=cpp
DATE=date
ECHO=echo
ECHON=echo -n
EXEC=exec
FIND=find
FOLLOW=-follow
NOLEAF=-noleaf
GREP=grep
KILL=kill
SLEEP=sleep
LD=ld
LMAKE=make
LN=ln
LNS=ln -s
MKDIR=mkdir
MV=mv
NM=nm
PERL=perl
RM=rm
RMF=rm -f
RMRF=rm -rf
SED=sed
SORT=sort
TOUCH=touch
XARGS=xargs
LS=ls

BINHOME=$(ORACLE_HOME)/bin/
LIBHOME=$(ORACLE_HOME)/lib/

ECHODO=$(BINHOME)echodo
GENSYSLIB=$(BINHOME)gensyslib
GENCLNTSH=$(BINHOME)genclntsh
GENNAFLG=$(BINHOME)gennaflg
GENAUTAB=$(BINHOME)genautab

ARCHIVE_OBJ=$(AR) r $@ $*.$(OBJ_EXT)
ARCREATE=$(AR) cr$(ARLOCAL)
ARDELETE=$(AR) d$(ARLOCAL)
AREXTRACT=$(AR) x 
ARPRINT=$(AR) t
ARREPLACE=$(AR) r 
DOAR=$(ARCREATE) $@ $? $(RANLIB)
MAKE=$(LMAKE)
QUIET=>/dev/null 2>&1
QUIETE=2>/dev/null
SILENT=@
CTSMAKEFLAGS=$(SILENT:@=--no-print-directory -s)

CFLAGS=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS)\
	$(SHARED_CFLAG) $(USRFLAGS)
PFLAGS=$(INCLUDE) $(SPFLAGS) $(LPFLAGS)

LDCCOM=$(PURECMDS) $(CC) $(GFLAG) $(CCFLAGS) $(EXOSFLAGS) $(LDFLAGS)
LDFLAGS=-o $@ -L$(PRODLIBHOME) -L$(LIBHOME)
LDLIBS=$(EXPDLIBS) $(EXOSLIBS) $(SYSLIBS) $(EXSYSLIBS) $(MATHLIB) $(USRLIBS)
MATHLIB=-lm
PURECMDS=$(PURELINK) $(PURIFY) $(PURECOV) $(QUANTIFY)

SYSLIBLIST=$(LIBHOME)sysliblist
SYSLIBS=`$(CAT) $(SYSLIBLIST)`

NACCFLAGS=$(LIBHOME)naccflgs
NALDFLAGS=$(LIBHOME)naldflgs
NACCFLAGSLIST=`$(CAT) $(NACCFLAGS)`
NALDFLAGSLIST=`$(CAT) $(NALDFLAGS)`

TTLIBD=$(NETLIBD) $(LIBRDBMS_CLT) $(LIBMM) $(CORELIBD) $(LIBEPC) $(LIBCLNTSH)
STATICTTLIBS=$(NAUTAB) $(NAETAB) $(NAEDHS) $(NALDFLAGSLIST) \
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LLIBMM) $(CORELIBS)\
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LIBPLS_CLT)\
       $(LLIBEPC) $(CORELIBS) $(LLIBRDBMS_CLT) $(CORELIBS) $(LDLIBS)
TTLIBS= $(STATICTTLIBS)
DEVTTLIBS=$(TTLIBS)

STLIBS=$(SGL_ON) $(CONFIG) $(LLIBSERVER) $(LLIBPLSF) $(LLIBSLAX) \
       $(LIBGENERIC) $(LLIBCLIENT) $(LLIBMM) $(LLIBKNLOPT) $(LLIBPLSB)\
       $(LLIBSERVER) $(LLIBEXTP) $(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NALDFLAGSLIST) $(NETLIBS) $(LLIBCLIENT) \
       $(LLIBPLSF) $(LLIBICX) $(LLIBOWSUTL) \
       $(NETLIBS) $(LLIBEPC) $(SDOLIBS) $(LLIBCORE) $(LLIBVSN) $(LLIBCOMMON)\
       $(LIBGENERIC) $(LLIBKNLOPT) $(NMLIBS) $(CARTLIBS) $(CORELIBS) $(LDLIBS)


PLATFORM=hpux

MOTIFHOME=/usr/lib/
OPENWINHOME=#
GUILIBHOME=#

SO_EXT=sl

GMAKE=gmake -r
LMAKE=/usr/ccs/bin/make
FIND=/usr/bin/find 
CPP=/opt/langtools/lbin/cpp
PS=ps -feda
SHELL=/usr/bin/sh
ARCHIVE=@`if echo ${LIB} | grep lib > /dev/null 2>&1;then $(ARCREATE) $(LIB) $? $(RANLIB); else echo ""; fi`

GROUP=/etc/group

LINK=cc  $(CCFLAGS) $(COMPOBJS)
LLIBTHREAD=/usr/lib/libcma.sl
MOTIFLIBS=-L$(MOTIFHOME)lib -lXm -L$(GUILIBHOME) -R$(GUILIBHOME)\
	-lXt -lX11 -lm
XLIBS=-L$(GUILIBHOME) -R$(GUILIBHOME) -lXt -lXmu -lXext -lX11 -lm

MOTIFINCLUDE=$(I_SYM)$(MOTIFHOME)include\
	$(I_SYM)$(MOTIFHOME)include/Xm

OPTIMIZE2=+O2
OPTIMIZE4=+O4
OPTIMIZE=$(OPTIMIZE2)

ROFLAGS=-c #-xMerge
SPFLAGS=##-DSLMXMX_ENABLE -DSLTS_ENABLE -D_REENTRANT

BUGDB_PORT=2
MKCUST_TARGET=mkcustinclude

AR=ar
AS=as
CC=cc
CPP=$(CC) -E $(ANSI)

ASFLAGS=-P
ASPFLAGS=-P $(PFLAGS)
ASRO=$(AS) $(ASROFLAGS) $(MAKERO) $<
ASROFLAGS=$(ASFLAGS)
CXC=-Ac
CXA=-Aa
CXE=-Ae   # -Aa -D_HPUX_SOURCE
ANSI=$(CXE)



HP800CCFLAGS=+DA1.0 +DS2.0 

HPTHREADFLAGS= -DHPUX_DCE  -DSLXMX_ENABLE -DSLMXMX_ENABLE  -DSLTS_ENABLE -D_REENTRANT

PFLAGS=$(INCLUDE) $(SPFLAGS) $(HPTHREADFLAGS) $(LPFLAGS)

HPUXFLAGS=-DHPUX $(HP800CCFLAGS) $(HPTHREADFLAGS) 

HPCCFLAGS=-DHPUX -z +Z  $(HPUXFLAGS) +Ofastaccess +Oentrysched +Onolimit \
           +ESlit +Oprocelim 
HPCCFLAGS_NOPIC=-DHPUX -z  $(HPUXFLAGS) +Ofastaccess +Oentrysched +Onolimit \
           +ESlit +Oprocelim 

HPCCFLAGS_NOESLIT= -Ae -DHPUX -z $(HPUXFLAGS) +Ofastaccess +Oentrysched +Onolimit +Oprocelim 

CCFLAGS=$(ANSI) $(HPCCFLAGS) +Olibcalls
FASTCCFLAGS=$(ANSI) -z $(HPCCFLAGS_NOPIC)

LDFLAGS= -Wl,-adefault -Wl,+s $(OPTIMIZE) -o $@ -L$(PRODLIBHOME) -L$(LIBHOME)
LDLIBS=$(EXPDLIBS) $(EXOSLIBS) $(SYSLIBS) $(EXSYSLIBS) $(MATHLIB) $(USRLIBS)$(LLIBTHREAD)


CCFLAGS_NOESLIT=$(ANSI) -z $(HPCCFLAGS_NOESLIT) 
CFLAGS_NOESLIT=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS_NOESLIT) $(QACCFLAGS)\
               $(PFLAGS) $(SHARED_CFLAG) $(USRFLAGS)
CFLAGS_NO_O_ESLIT=$(GFLAG) $(CDEBUG) $(CCFLAGS_NOESLIT) $(QACCFLAGS)\
               $(PFLAGS) $(SHARED_CFLAG) $(USRFLAGS)
CFLAGS__ESLIT=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS)\
               $(PFLAGS) $(SHARED_CFLAG) $(USRFLAGS)

COMPZNOESLIT=$(CC) $< -c  +Z $(CFLAGS_NOESLIT)  -o $@ 
COMPZNOOESLIT=$(CC) $< -c  +Z $(CFLAGS_NO_O_ESLIT)  -o $@
COMPZ=$(CC) $< -c  +Z $(CFLAGS__ESLIT) -o $@
JAVA_HOME=/opt/jdk/java
JAVA_INCLUDE = -I $(JAVA_HOME)/include -I $(JAVA_HOME)/include/hp-ux
COMP_JAVA=$(CC) $< -c  +Z  $(CCFLAGS) $(JAVA_INCLUDE) -o $@

CCFLAGS_NO_O= $(CCFLAGS)
CFLAGS_NO_O= $(GFLAG) $(CDEBUG) $(CCFLAGS_NO_O) $(QACCFLAGS) $(PFLAGS) \
               $(SHARED_CFLAG)
COMP_NO_O=$(CC) -c $(CFLAGS_NO_O) $<
MAKE_LIB_OBJ_NO_O=$(COMP_NO_OPT) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)


HPLFFLAGS= $(COMPZ) -D_FILE_OFFSET_BITS=64
HPLFFLAGS_NOESLIT= $(COMPZNOESLIT) -D_FILE_OFFSET_BITS=64
LIBNETV2     = $(LIBHOME)libnetv2.$(LIB_EXT)
LLIBNETV2    = -lnetv2

LIBNTTCP     = $(LIBHOME)libnttcp.$(LIB_EXT)
LLIBNTTCP    = -lnttcp

LIBNTOD      = $(LIBHOME)libntod.$(LIB_EXT)
LLIBNTOD     = -lntod

LIBNTLU62    = $(LIBHOME)libntlu62.$(LIB_EXT)
LLIBNTLU62   = -lntlu62

LIBNTS       = $(LIBHOME)libnts.$(LIB_EXT)
LLIBNTS      = -lnts

LIBNETWORK   = $(LIBHOME)libnetwork.$(LIB_EXT)  	
LLIBNETWORK  = -lnetwork

LIBSQLNET    = $(LIBNETV2)   $(LIBNTTCP)  $(LIBNETWORK)
LLIBSQLNET   = $(LLIBNETV2) $(LLIBNTTCP) $(LLIBNETWORK)

LIBRPC       = $(LIBHOME)libncr.$(LIB_EXT)
LLIBRPC      = -lncr 

LIBTNSAPI    = $(NETWORKLIB)libtnsapi.$(LIB_EXT)
LLIBTNSAPI   = -ltnsapi

TNSLSNR	     = $(BINHOME)tnslsnr
LSNRCTL	     = $(BINHOME)lsnrctl
NAMES	     = $(BINHOME)names
NAMESCTL     = $(BINHOME)namesctl

NIGTAB       = $(LIBHOME)nigtab.$(OBJ_EXT)
NIGCON       = $(LIBHOME)nigcon.$(OBJ_EXT) 
NTCONTAB     = $(LIBHOME)ntcontab.$(OBJ_EXT)
MTS_NCR	     = $(LIBHOME)ncrstab.$(OBJ_EXT)

OSNTABST     = $(NETWORKLIB)osntabst.$(OBJ_EXT)
NNFGT        = $(NETWORKLIB)nnfgt.$(OBJ_EXT)

NAETAB       = $(LIBHOME)naeet.$(OBJ_EXT) $(LIBHOME)naect.$(OBJ_EXT)
NAEDHS	     = $(LIBHOME)naedhs.$(OBJ_EXT)
NAUTAB	     = $(LIBHOME)nautab.$(OBJ_EXT)

NETLIBS      = $(LLIBSQLNET) $(LLIBRPC) $(LLIBSQLNET)
NETLIBD      = $(LIBSQLNET) $(LIBRPC)
NATIVE =

COREHOME= $(ORACLE_HOME)/oracore/
ORACOREHOME= $(COREHOME)

LIBCORE= $(LIBHOME)libcore4.$(LIB_EXT)
LLIBCORE= -lcore4

S0MAIN= $(LIBHOME)s0main.o
SCOREPT= $(LIBHOME)scorept.o
SSCOREED= $(LIBHOME)sscoreed.o

COREPUBLIC=$(COREHOME)include/ $(COREHOME)public/
ORACOREPUBH=$(I_SYM)$(COREHOME)include $(I_SYM)$(COREHOME)public

CORELIBD=$(LIBNLSRTL) $(LIBCV6) $(LIBCORE) $(LIBNLSRTL) $(LIBCORE) $(LIBNLSRTL)
CORELIBS=$(LLIBNLSRTL) $(LLIBCV6) $(LLIBCORE) $(LLIBNLSRTL) $(LLIBCORE) $(LLIBNLSRTL)

NLSRTLHOME= $(ORACLE_HOME)/nlsrtl/

ORA_NLS = $(ORACLE_HOME)/ocommon/nls/admin/data/
ORA_NLS33 = $(ORACLE_HOME)/ocommon/nls/admin/data/

LIBNLSRTL= $(LIBHOME)libnlsrtl3.$(LIB_EXT)
LLIBNLSRTL= -lnlsrtl3

NLSRTLPUBH = $(I_SYM)$(NLSRTLHOME)include
LIBSERVER=$(LIBHOME)libserver.$(LIB_EXT)
LLIBSERVER=-lserver

LIBCLIENT=$(LIBHOME)libclient.$(LIB_EXT)
LLIBCLIENT=-lclient

LIBGENERIC=$(LIBHOME)libgeneric.$(LIB_EXT)
LLIBGENERIC=-lgeneric

LIBCOMMON=$(LIBHOME)libcommon.$(LIB_EXT)
LLIBCOMMON=-lcommon

LIBVSN=$(LIBHOME)libvsn.$(LIB_EXT)
LLIBVSN=-lvsn

LIBAGENT=$(LIBHOME)libagent.$(LIB_EXT)
LLIBAGENT=-lagent

DLMHOME=$(ORACLE_HOME)/odlm/

SKGXNS=$(RDBMSLIB)skgxns.$(OBJ_EXT)
SKGXND=$(RDBMSLIB)skgxnd.$(OBJ_EXT)
SKGXN=$(RDBMSLIB)skgxn.$(OBJ_EXT)

LIBDLM=$(SKGXN) $(LIBHOME)libudlm.$(LIB_EXT)
LLIBDLM=$(SKGXN) -ludlm

LIBNM=$(LIBDLM)
LLIBNM=$(LLIBDLM)
NMLIBLIST=$(RDBMSLIB)nmliblist
NMLIBS=`$(CAT) $(NMLIBLIST)`

LIBMM=$(LIBHOME)libmm.$(LIB_EXT)
LLIBMM=-lmm


LIBRDBMS_CLT=$(LIBCLIENT) $(LIBVSN) $(LIBCOMMON) $(LIBGENERIC)
LLIBRDBMS_CLT=$(LLIBCLIENT) $(LLIBVSN) $(LLIBCOMMON) $(LLIBGENERIC)

LIBCLNTSH=$(LIBHOME)libclntsh.$(SO_EXT)
LLIBCLNTSH=-lclntsh

CONFIG = $(RDBMSLIB)config.$(OBJ_EXT)

SDOLIBS = `if ${AR} tv ${ORACLE_HOME}/rdbms/lib/libknlopt.a | grep "kxmnsd.o" > /dev/null 2>&1 ; then echo " " ; else echo "-lmdknl -lmdhh"; fi`

DEF_ON= $(RDBMSLIB)kpudfo.$(OBJ_EXT)
DEF_OFF= $(RDBMSLIB)kpundf.$(OBJ_EXT)
DEF_OPT= $(RDBMSLIB)defopt.$(OBJ_EXT)

LIBSLAX=$(LIBHOME)libslax.a
LLIBSLAX=-lslax

LIBSQL=$(LIBHOME)libsql.$(LIB_EXT)
LLIBSQL=-lsql

LIBSVRM= $(LIBHOME)smalmain.$(OBJ_EXT) $(LIBHOME)libsvrmgrl.$(LIB_EXT) $(LIBHOME)libslpm.$(LIB_EXT)
LLIBSVRM= $(LIBHOME)smalmain.$(OBJ_EXT) -lsvrmgrl -lslpm

RDBMSHOME=$(ORACLE_HOME)/rdbms/
RDBMSLIB=$(RDBMSHOME)lib/
RDBMSADMIN=$(RDBMSHOME)admin/

EPCLIBS=$(LLIBEPC)

LIBEPC=$(LIBHOME)libepc.$(LIB_EXT)
LLIBEPC=-lepc

LIBEPCPT=$(LIBHOME)libepcpt.$(LIB_EXT)
LLIBEPCPT=-lepcpt

LIBEPCFE=$(LIBHOME)libepcfe.$(LIB_EXT)
LLIBEPCFE=-lepcfe

LIBEXTP=$(LIBHOME)libextp.$(LIB_EXT)
LLIBEXTP=-lextp

WRAP=$(BINHOME)wrap

LIBPLSB=$(LIBHOME)libplsb.$(LIB_EXT)
LLIBPLSB=-lplsb
LIBPLSF=$(LIBHOME)libplsf.$(LIB_EXT)
LLIBPLSF=-lplsf
PLSQLLIBS=$(LIBPLSF) $(LIBPLSB)
LPLSQLLIBS=$(LLIBPLSF) $(LLIBPLSB)

LLIBPLSQL= $(LPLSQLLIBS) $(LLIBEXTP)

LIBICD=$(LIBHOME)libicd.$(LIB_EXT)
LLIBICD=-licd
LIBPSD=$(LIBHOME)libpsd.$(LIB_EXT)
LLIBPSD=-lpsd
LIBPSA=$(LIBHOME)libpsa.$(LIB_EXT)
LLIBPSA=-lpsa

# Entering /project/805/src/plsql/s_exports.mk
 
# Exiting /project/805/src/plsql/s_exports.mk
# Exiting /project/805/src/plsql/exports.mk
 
# Entering /project/805/src/precomp/exports.mk
TOP = $(ORACLE_HOME)/precomp
LIBSQL= $(LIBHOME)libsql.$(LIB_EXT)
LLIBSQL= -lsql
 
PRODUCT=precomp
PRECOMPHOME= $(ORACLE_HOME)/precomp/
PRODHOME=$(PRECOMPHOME)
PRECOMPADMIN=$(PRECOMPHOME)admin/
PRECOMPLIB=$(PRECOMPHOME)lib/
 
PRECOMPPUBH=$(I_SYM)$(PRECOMPHOME)public $(I_SYM)$(PRECOMPHOME)include
 
# Entering /project/805/src/precomp/s_exports.mk
 
# Exiting /project/805/src/precomp/s_exports.mk

# Exiting /project/805/src/precomp/exports.mk

ADE_DEL_FILE=echo ""

PRECOMPLIB=$(PRECOMPHOME)lib/
PRECOMPMESG=$(PRECOMPHOME)mesg/
PRECOMPBIN=$(PRECOMPHOME)bin/
PRECOMPADMIN=$(PRECOMPHOME)admin/
PRECOMPINSTALL=$(PRECOMPHOME)install/
PRECOMPDEMO=$(PRECOMPHOME)demo/
PRECOMPADALIB=$(PRECOMPHOME)pubsrc/adalib

PRODLIBHOME=$(PRECOMPLIB)

 
 
LIBPAD=$(PRECOMPLIB)libpad.$(LIB_EXT)
LIBPC=$(PRECOMPLIB)libpc.$(LIB_EXT)
LIBPCC=$(PRECOMPLIB)libpcc.$(LIB_EXT)
LIBPCD=$(PRECOMPLIB)libpcd.$(LIB_EXT)
LIBPCO=$(PRECOMPLIB)libpco.$(LIB_EXT)
LIBPFO=$(PRECOMPLIB)libpfo.$(LIB_EXT)
LIBPGP=$(PRECOMPLIB)libpgp.$(LIB_EXT)
LIBPPL=$(PRECOMPLIB)libppl.$(LIB_EXT)
LIBPPA=$(PRECOMPLIB)libppa.$(LIB_EXT)
LIBPROC2=$(PRECOMPLIB)libproc2.$(LIB_EXT)
LIBMOD=$(PRECOMPLIB)libmod.$(LIB_EXT)
LIBSQL=$(LIBHOME)libsql.$(LIB_EXT)
LIBPDC=$(PRECOMPLIB)libpdc.$(LIB_EXT)
LIBOTT=$(PRECOMPLIB)libots2c.$(LIB_EXT)
LIBPROCOB2=$(PRECOMPLIB)libprocob2.$(LIB_EXT)
LIBFIDL=$(PRECOMPLIB)libfidl.$(LIB_EXT)

PRECOMP_LIBS=$(LIBPAD) $(LIBPC) $(LIBPCC) $(LIBPCO) $(LIBPFO) \
             $(LIBPGP) $(LIBPPL) $(LIBPPA) $(LIBPCD) $(LIBPROC2) \
             $(LIBMOD) $(LIBSQL) $(LIBPDC) $(LIBOTT) $(LIBPROCOB2) $(LIBFIDL)
 
PC5DRV=pc5drv.$(OBJ_EXT)
PC0DRV=pc0drv.$(OBJ_EXT)
PC2DRV=pc2drv.$(OBJ_EXT)
PC1DRV=pc1drv.$(OBJ_EXT)
PC4DRV=pc4drv.$(OBJ_EXT)
PC3DRV=pc3drv.$(OBJ_EXT)
PMSCPR=pmscpr.$(OBJ_EXT)
PMSAPR=pmsapr.$(OBJ_EXT)
PROC2OBJS=main.$(OBJ_EXT) sspced.$(OBJ_EXT) spcpt.$(OBJ_EXT) pcprnt.$(OBJ_EXT)
MODOBJS=
OTTOBJS=o2m.$(OBJ_EXT) so2ed.$(OBJ_EXT) so2pt.$(OBJ_EXT)
PROCOB2OBJS=pcbd.$(OBJ_EXT) pcbrnt.$(OBJ_EXT)
FIDLOBJS=fdmain.$(OBJ_EXT)

ADAMAIN=$(PRECOMPLIB)$(PC5DRV)
COBMAIN=$(PRECOMPLIB)$(PC0DRV)
CMAIN=$(PRECOMPLIB)$(PC2DRV)
FORMAIN=$(PRECOMPLIB)$(PC1DRV)
PASMAIN=$(PRECOMPLIB)$(PC4DRV)
PLIMAIN=$(PRECOMPLIB)$(PC3DRV)
MODCMAIN=$(PRECOMPLIB)$(PMSCPR)
MODADAMAIN=$(PRECOMPLIB)$(PMSAPR)
MAINOBJS=$(PRECOMPLIB)main.$(OBJ_EXT) $(PRECOMPLIB)sspced.$(OBJ_EXT) \
	$(PRECOMPLIB)spcpt.$(OBJ_EXT) $(PRECOMPLIB)pcprnt.$(OBJ_EXT)
MODOBJS=
O2MAIN=$(PRECOMPLIB)o2m.$(OBJ_EXT) $(PRECOMPLIB)so2ed.$(OBJ_EXT) \
		$(PRECOMPLIB)so2pt.$(OBJ_EXT)
COB2MAIN=$(PRECOMPLIB)pcbd.$(OBJ_EXT) $(PRECOMPLIB)pcbrnt.$(OBJ_EXT)
FIDLMAIN=$(PRECOMPLIB)$(FIDLOBJS)
 
PDAOBJ=pda.$(OBJ_EXT)
PDCOBJ=pdc.$(OBJ_EXT)
PDBOBJ=pdb.$(OBJ_EXT)
PDFOBJ=pdf.$(OBJ_EXT)
PDPOBJ=pdp.$(OBJ_EXT)
PD1OBJ=pd1.$(OBJ_EXT)
PDSOBJ=pds.$(OBJ_EXT)
CODEGENOBJS=$(PDAOBJ) $(PDCOBJ) $(PDBOBJ) $(PDFOBJ) \
		$(PDPOBJ) $(PD1OBJ) $(PDSOBJ)

ADAPDC=$(PRECOMPLIB)$(PDAOBJ) $(PRECOMPLIB)$(PDSOBJ)
CPDC=$(PRECOMPLIB)$(PDCOBJ) $(PRECOMPLIB)$(PDSOBJ)
COBPDC=$(PRECOMPLIB)$(PDBOBJ) $(PRECOMPLIB)$(PDSOBJ)
FORPDC=$(PRECOMPLIB)$(PDFOBJ) $(PRECOMPLIB)$(PDSOBJ)
PASPDC=$(PRECOMPLIB)$(PDPOBJ) $(PRECOMPLIB)$(PDSOBJ)
PLIPDC=$(PRECOMPLIB)$(PD1OBJ) $(PRECOMPLIB)$(PDSOBJ)

PRECOMP_OBJFILES= $(ADAPDC) $(CPDC) $(COBPDC) $(FORPDC) $(PASPDC) \
		  $(PLIPDC) $(PRECOMPLIB)$(PDSOBJ) \
		  $(ADAMAIN) $(COBMAIN) $(CMAIN) $(FORMAIN) $(PASMAIN) \
		  $(PLIMAIN) $(MODCMAIN) $(MODADAMAIN) $(O2MAIN) \
		  $(MAINOBJS) $(COB2MAIN) $(FIDLMAIN)

STATICPROLDLIBS=$(LLIBCLIENT) $(LIBSQL) $(SCOREPT) $(SSCOREED) $(DEF_ON) $(DEVTTLIBS) $(LLIBTHREAD)
PROLDLIBS=$(LLIBCLNTSH) $(STATICPROLDLIBS)

PROADA=proada
PROCOB18=procob18
PROC16=proc16
PROFOR=profor
PROPAS=propas
PROPLI=propli
PROC=proc
OTT=ott
MODC=modc
MODADA=modada
PROCOB=procob
FIDL=fidl
RTSORA=rtsora

ASFLAGS=-K PIC

LLAIO= 
LLIBTHREAD=-lcma

CCPSYSINCLUDE=sys_include='(/opt/aCC/include,/opt/aCC/include/SC,/opt/aCC/include/iostream,/opt/aCC/include/rw,/usr/include)'
CCP=/opt/aCC/bin/aCC
ADAPORT=verdix
ADACC=ada -e
ADALD=a.ld
ADACLEAN= a.rmlib -f

COB = cob
COBFLAGS=-C IBMCOMP -C NESTCALL -x
COBGNTFLAGS=-C IBMCOMP -C NESTCALL -u
GNT=.gnt
COBSQLINTF=$(PRECOMPLIB)cobsqlintf.o

FC=f77




# This Makefile builds the sample programs in 
# $(ORACLE_HOME)/precomp/demo/proc, and can serve as a template for linking
# customer applications.
#
# SAMPLES is a list of the c proc sample programs.
# CPPSAMPLES is a list of the c++ proc sample programs.
# OBJECT_SAMPLES is a list of the proc sample programs using the new
# type features.  You must install ott in addition to proc to run some
# of those samples.
#

#
# These targets are build all of a class of samples in one call to make.
#
#
# The target 'build' puts together an executable $(EXE) from the .o files
# in $(OBJS) and the libraries in $(PROLDLIBS).  It is used to build the
# c sample programs.  The rules to make .o files from .c and .pc files are
# later in this file.
# ($(PROLDLIBS) includes the client shared library, and $(STATICPROLDLIBS) does
# not.)
#
build: $(OBJS)
	$(CC) -o $(EXE) $(OBJS) -L$(LIBHOME) $(LIBCLNTSH) $(LIBSQL) 
build_static: $(OBJS)
	$(CC) -o $(EXE) $(OBJS) -L$(LIBHOME) $(STATICPROLDLIBS)
cppbuild: 
	$(PROC) $(PROCPPFLAGS) iname=$(EXE)
	CC -c $(INCLUDE) $(EXE).c
	CC -o $(EXE) $(OBJS) -L$(LIBHOME) $(CPPLDLIBS)
cppbuild_static: 
	$(PROC) $(PROCPPFLAGS) iname=$(EXE)
	CC -c $(INCLUDE) $(EXE).c
	CC -o $(EXE) $(OBJS) -L$(LIBHOME) $(STATICCPPLDLIBS)
.SUFFIXES: .pc .c .o .typ .h

.pc.c:
	$(PROC) $(PROCFLAGS) iname=$*

.pc.o:
	$(PROC) $(PROCFLAGS) iname=$*
	$(CC) $(CFLAGS) -c $*.c

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.typ.h:
	$(OTT) intype=$*.typ hfile=$*.h outtype=$*o.typ $(OTTFLAGS) code=c user=pb/internet98
#
# These are specific targets to make the .o files for samples that require
# more careful handling.
#
# The macro definition fill in some details or override some defaults from 
# other files.
#
OTTFLAGS=$(PCCFLAGS)
CLIBS= $(TTLIBS_QA) $(LDLIBS)
PRODUCT_LIBHOME=
MAKEFILE=$(ORACLE_HOME)/precomp/demo/proc/demo_proc.mk
PROCPLSFLAGS= sqlcheck=full userid=$(USERID) 
PROCPPFLAGS= code=cpp $(CCPSYSINCLUDE)
USERID=pb/internet98
NETWORKHOME=$(ORACLE_HOME)/network/
PLSQLHOME=$(ORACLE_HOME)/plsql/
INCLUDE=$(I_SYM). $(I_SYM)$(PRECOMPHOME)public $(I_SYM)$(RDBMSHOME)public $(I_SYM)$(RDBMSHOME)demo $(I_SYM)$(PLSQLHOME)public $(I_SYM)$(NETWORKHOME)public
I_SYM=-I
STATICPROLDLIBS=$(SCOREPT) $(SSCOREED) $(DEF_ON) $(LLIBCLIENT) $(LLIBSQL) $(TTLIBS)
PROLDLIBS=$(LLIBCLNTSH) $(STATICPROLDLIBS)
STATICCPPLDLIBS=$(SCOREPT) $(SSCOREED) $(DEF_ON) $(LLIBCLIENT) $(LLIBSQL) $(DEVTTLIBS)
CPPLDLIBS=$(LLIBCLNTSH) $(STATICCPPLDLIBS)
