-- ***************************************
-- TP5
-- Groupe MG2G4 - Baba NGOM, David ROUSSE
-- ***************************************

-- 1
-- (a)

DROP VIEW POSTE_0;

CREATE VIEW POSTE_0(N_POS_0, N_SAL_0, TYP_0, N_SEG_1, A0)
AS 
SELECT N_POSTE, N_SALLE, TYPE_P, N_SEGMENT, AD
FROM POSTE
WHERE
N_SEGMENT IN (  SELECT N_SEGMENT
		FROM SEGMENT
		WHERE ETAGE = 0);

-- (b)

SELECT * 
FROM POSTE_0;

SET LONG 1000;

COLUMN VIEW_NAME FORMAT A13 HEADING 'Nom de la vue'
COLUMN TEXT_LENGTH HEADING 'Longueur'
COLUMN TEXT FORMAT A40 HEADING 'Description'

SELECT VIEW_NAME, TEXT_LENGTH, TEXT 
FROM USER_VIEWS
WHERE VIEW_NAME = 'POSTE_0';

CLEAR COLUMN;

-- (c)

INSERT INTO POSTE_0 VALUES ('p13','s01','TX','130.120.80','08');
INSERT INTO POSTE_0 VALUES ('p14','s11','PCNT','130.120.81','09');

-- (d)		  

SELECT * 
FROM POSTE_0;

-- Dans la vue POSTE_0, seul le tuple insere appartenant a l'etage 0 
-- apparait alors que les deux tuples inseres
-- apparaissent dans la table POSTE

SELECT * 
FROM POSTE;

DELETE FROM POSTE_0 WHERE N_POS_0 = 'p13'; 
DELETE FROM POSTE_0 WHERE N_POS_0 = 'p14'; 
-- le tuple correspondant au poste p14 n'est pas supprime de 
-- POSTE_0 car p14 n'appartient a l'etage 0 mais il est toujours present
-- dans POSTE
DELETE FROM POSTE WHERE N_POSTE = 'p14';
				
-- (e)

DROP VIEW SALLE_PRIX;			

CREATE VIEW SALLE_PRIX(N_SALLE, NOM_S, NB_POSTE, PRIX_LOCATION)
AS
SELECT N_SALLE, NOM_S, NB_POSTE, NB_POSTE*100
FROM SALLE;

-- (f)

ACCEPT PRIX PROMPT 'Entrez le prix :';

TTITLE ON

COLUMN N_SALLE FORMAT A7 HEADING 'NSalle'
COLUMN NOM_S FORMAT A10 HEADING 'Salle'
COLUMN PRIX_LOCATION HEADING 'Prix de location'

TTITLE LEFT 'PAGE' SQL.PNO -
SKIP 2 CENTER 'Salles dont le prix de location > &PRIX F' SKIP 2

SELECT N_SALLE, NOM_S, PRIX_LOCATION
FROM SALLE_PRIX
WHERE PRIX_LOCATION > &PRIX;

CLEAR COLUMN
TTITLE OFF

-- mme requte sans utiliser la vue
SELECT N_SALLE, NOM_S, NB_POSTE*100
FROM SALLE
WHERE NB_POSTE*100 > &PRIX;

-- (g)

-- ajout puis mise  jour de la colonne TARIF dans TYP_LP

ALTER TABLE TYPE ADD (TARIF NUMBER(4));

UPDATE TYPE SET TARIF = 50 WHERE TYP_LP = 'TX';
UPDATE TYPE SET TARIF = 100 WHERE TYP_LP = 'PCWS';
UPDATE TYPE SET TARIF = 120 WHERE TYP_LP = 'PCNT';
UPDATE TYPE SET TARIF = 200 WHERE TYP_LP = 'UNIX';
UPDATE TYPE SET TARIF = 80 WHERE TYP_LP = 'NC';

SELECT TYP_LP, TARIF
FROM TYPE;

DROP VIEW SALLE_PRIX;			

CREATE VIEW SALLE_PRIX(N_SALLE, PRIX_LOCATION)
AS
SELECT POSTE.N_SALLE, SUM(TARIF)
FROM TYPE, POSTE, SALLE  
WHERE TYP_LP = TYPE_P
AND SALLE.N_SALLE = POSTE.N_SALLE
GROUP BY POSTE.N_SALLE;

SELECT * FROM SALLE_PRIX;


-- 2
-- (a)

DROP VIEW INSTALLATIONS;

CREATE VIEW INSTALLATIONS(NOM_POSTE,NOM_LOGICIEL,DATE_INSTALLATION)
AS 
SELECT NOM_P, NOM_L, DATE_INS
FROM INSTALLER,LOGICIEL,POSTE
WHERE INSTALLER.N_POSTE = POSTE.N_POSTE
AND INSTALLER.N_LOG = LOGICIEL.N_LOG;

SELECT * FROM INSTALLATIONS;

-- (b)

DROP VIEW SALLE_POSTE;

CREATE VIEW SALLE_POSTE(NOM_S,NOM_POSTE,ADRESSE_IP,NOM_TYPE_POSTE)
AS 
SELECT NOM_S, NOM_P, POSTE.N_SEGMENT||'.'||AD, NOM_TYPE
FROM SALLE, POSTE, TYPE
WHERE SALLE.N_SALLE = POSTE.N_SALLE
AND TYPE_P = TYP_LP;

SELECT * FROM SALLE_POSTE;


-- 3
-- (a)

DROP VIEW POSTE_0;

CREATE VIEW POSTE_0(N_POS_0, N_SAL_0, TYP_0, N_SEG_1, A0)
AS 
SELECT N_POSTE, N_SALLE, TYPE_P, N_SEGMENT, AD
FROM POSTE
WHERE N_SEGMENT LIKE '%80'
WITH CHECK OPTION CONSTRAINT CK_N_SEGMENT_0;

-- (b)

INSERT INTO POSTE_0 VALUES ('p14','s11','PCNT','130.120.81','09');

SELECT * 
FROM POSTE_0;

SELECT * FROM POSTE;

-- (c)


DROP VIEW INSTALLER_0;

CREATE VIEW INSTALLER_0(N_POSTE, N_LOG, DATE_INS)
AS 
SELECT N_POSTE, N_LOG, DATE_INS
FROM INSTALLER 
WHERE N_POSTE IN (SELECT N_POSTE
		  FROM POSTE
		  WHERE N_SEGMENT LIKE '%80')
AND N_LOG NOT IN (SELECT N_LOG
		  FROM LOGICIEL
		  WHERE TYPE_L = 'PCNT')
WITH CHECK OPTION CONSTRAINT CK_N_POS_0_AND_PCNT;

INSERT INTO INSTALLER_0 VALUES ('p8','log1','15-MAY-99');
INSERT INTO INSTALLER_0 VALUES ('p1','log3','15-MAY-99');

SELECT * 
FROM INSTALLER_0;

SELECT * FROM INSTALLER;



	
-- ***************************************
-- Fin des requetes du TP5
-- ***************************************

-- Instructions pour affichage de USER_CONSTRAINTS ET USER_VIEWS
clear column

set pagesize 30
set linesize 80

ttitle on
btitle on

column Jour noprint new_value Aujourdhui
column OWNER format A20 heading 'NOM PROPRIETAIRE'
column CONSTRAINT_NAME format A20 heading 'NOM CONTRAINTE'
column CONSTRAINT_TYPE format A15 heading 'TYPE CONTRAINTE'
column TABLE_NAME heading 'NOM DE LA TABLE'
column STATUS format A10 heading 'STATUS'
column VALIDATED format A10 heading 'VALIDE ?'
column GENERATED format A10 heading 'GENERE PAR'
column LAST_CHANGE format A15 heading 'DERNIERE MODIF.'

ttitle left 'PAGE' SQL.PNO right Aujourdhui -
skip 2 center 'Table USER_CONSTRAINTS' skip 2
btitle left 'Fin de USER_CONSTRAINTS'

break on OWNER skip 3
select to_char(sysdate,('dd/mm/yyyy')) Jour, OWNER, CONSTRAINT_NAME, CONSTRAINT_TYPE, TABLE_NAME, STATUS, VALIDATED, GENERATED, LAST_CHANGE
from USER_CONSTRAINTS
order by OWNER;
clear break

clear column
ttitle off
btitle off


TTITLE ON
BTITLE ON

COLUMN VIEW_NAME FORMAT A13 HEADING 'Nom de la vue'
COLUMN TEXT_LENGTH HEADING 'Longueur'
COLUMN TEXT FORMAT A40 HEADING 'Description'

TTITLE LEFT 'PAGE' SQL.PNO RIGHT AUJOURDHUI -
SKIP 2 CENTER 'TABLE USER_VIEWS' SKIP 2
BTITLE LEFT 'FIN DE USER_VIEWS'

SELECT VIEW_NAME, TEXT_LENGTH, TEXT 
FROM USER_VIEWS;

CLEAR COLUMN
TTITLE OFF
BTITLE OFF


	

