-- 1
SET PAGESIZE 30;
SPOOL tracet1.sql;

-- cration de la table COMPTE_RENDU (sans contraintes)
DROP TABLE COMPTE_RENDU;
CREATE TABLE COMPTE_RENDU
(
	LIGNE_COMPTE_RENDU VARCHAR(80)
);


-- dbut du bloc PL/SQL
DECLARE	
	CURSOR CURSEURPOSTE IS 	
	SELECT N_POSTE, NOM_P, NOM_S, TYPE_P
	FROM POSTE, SALLE
	WHERE POSTE.N_SEGMENT = '&NumSegment'
	AND TYPE_P = '&TypeLogiciel'
	AND POSTE.N_SALLE = SALLE.N_SALLE;
	MESSAGE COMPTE_RENDU.LIGNE_COMPTE_RENDU%TYPE;
	FK_ERREUR EXCEPTION;
	PRAGMA EXCEPTION_INIT(FK_ERREUR,-2291);
	NOT_NULL_ERREUR EXCEPTION;
	PRAGMA EXCEPTION_INIT(NOT_NULL_ERREUR,-2291);
	TYPE_POSTE_LOG_ERREUR EXCEPTION;
	DATE_ACHAT_ERREUR EXCEPTION;
--	PRAGMA EXCEPTION_INIT(DATE_ACHAT_ERREUR ,-20000);
	DUP_VAL_ON_INDEX EXCEPTION;
	NUM_UDP INTEGER;
BEGIN	
	NUM_UDP:=1;
	IF &TypeLogiciel IS NULL THEN
		RAISE NOT_NULL;
	END IF;
	IF &TypeLogiciel <> CURSEURPOSTE_REC.TYPE_P THEN
		RAISE TYPE_POSTE_LOG_ERREUR;
	END IF;
	IF TO_DATE(&DateAchatLogiciel) > TO_DATE(SYSDATE) THEN
		RAISE DATE_ACHAT_ERREUR;
	END IF;
	INSERT INTO LOGICIEL VALUES
 	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);
	
	MESSAGE := 'Enregistrememt du logiciel &NomLogiciel dans LOGICIEL';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);

	NUM_UDP:=2;	
	FOR CURSEURPOSTE_REC IN CURSEURPOSTE LOOP
		INSERT INTO INSTALLER VALUES
		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
		
		UPDATE POSTE SET NB_LOG = NB_LOG + 1 WHERE CURSEURPOSTE_REC.N_POSTE = POSTE.N_POSTE;
		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
				
		MESSAGE := 'Installation sur le '||CURSEURPOSTE_REC.NOM_P||' dans la salle '||CURSEURPOSTE_REC.NOM_S;	
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	END LOOP;
	MESSAGE := 'Transaction reussie !';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	
	COMMIT;
EXCEPTION
	WHEN DUP_VAL_ON_INDEX THEN
		ROLLBACK;
		IF NUM_UDP=1 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
		ELSIF NUM_UDP=2 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Le '||:CURSEURPOSTE_REC.N_POSTE||' est deja prsent dans POSTE.');
		END IF;
	WHEN FK_ERREUR THEN
		ROLLBACK;
		IF NUM_UDP=1 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Type de logiciel inconnu.');
		ELSIF NUM_UDP=2 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Numero de segment inconnu.');
		END IF;
	WHEN NOT_NULL_ERREUR THEN
		ROLLBACK;
		IF NUM_UDP=1 THEN		
			INSERT INTO COMPTE_RENDU VALUES ('Violation de cl trangre');
		ELSIF NUM_UDP=2 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Violation de cl trangre');
		END IF;
	WHEN DATE_ACHAT_ERREUR THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Date d''achat du logiciel superieure a la date du jour.');		
	WHEN TYPE_POSTE_LOG_ERREUR THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Aucune installation possible sur ce segment: pas de poste de ce type.');			
	WHEN OTHERS THEN
		ROLLBACK;
		MESSAGE:=SUBSTR(SQLERRM,1,80);
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);		
END;
/
-- fin du bloc PL/SQL
-- REMARQUE : les 2 UPDATE realises devraient normalement etre inutiles car des triggers
-- sont en theorie prevus pour ce traitement (TP6)
-- mise au point du bloc
SHOW ERRORS;

SELECT * FROM COMPTE_RENDU;
