-- 1
SET PAGESIZE 30;
--SPOOL tracet1.sql;

-- cration de la table COMPTE_RENDU (sans contraintes)
DROP TABLE COMPTE_RENDU;
CREATE TABLE COMPTE_RENDU
(
	LIGNE_COMPTE_RENDU VARCHAR(80)
);

PROMPT 'Entrez le numro du segment :'
ACCEPT NumSegment

PROMPT 'Entrez le numro du logiciel :'
ACCEPT NumLogiciel

PROMPT 'Entrez le nom du logiciel :'
ACCEPT NomLogiciel

PROMPT 'Entrez la date d''achat du logiciel :'
ACCEPT DateAchatLogiciel

PROMPT 'Entrez la version du logiciel :'
ACCEPT VersionLogiciel

PROMPT 'Entrez le type du logiciel :'
ACCEPT TypeLogiciel

-- dbut du bloc PL/SQL
DECLARE	
	CURSOR CURSEURPOSTE IS 	
	SELECT N_POSTE, NOM_P, NOM_S
	FROM POSTE, SALLE
	WHERE POSTE.N_SEGMENT = '&NumSegment'
	AND TYPE_P = '&TypeLogiciel'
	AND POSTE.N_SALLE = SALLE.N_SALLE;
	MESSAGE COMPTE_RENDU.LIGNE_COMPTE_RENDU%TYPE;
	FK_TYPE_LOG EXCEPTION;
	PRAGMA EXCEPTION_INIT(FK_TYPE_LOG,-2291);
	NOT_NULL_ERREUR EXCEPTION;
	TYPE_POSTE_LOG_ERREUR EXCEPTION;
	DATE_ACHAT_ERREUR EXCEPTION;

	NO_DATA_FOUND EXCEPTION;
	PRAGMA EXCEPTION_INIT(NO_DATA_FOUND,+100);
	NUM_UDP INTEGER;
	NB INTEGER;
	NumSeg SEGMENT.N_SEGMENT%TYPE;
BEGIN	
	NUM_UDP := 1;
	
	SELECT N_SEGMENT INTO NumSeg FROM SEGMENT 
	WHERE N_SEGMENT='&NumSegment';
	
	IF TO_DATE('&DateAchatLogiciel') > TO_DATE(SYSDATE) THEN
		RAISE DATE_ACHAT_ERREUR;
	END IF;
		
	INSERT INTO LOGICIEL VALUES
 	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);

	MESSAGE := 'Enregistrement du logiciel &NomLogiciel dans LOGICIEL';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	
	SELECT COUNT(*) INTO NB FROM POSTE 
	WHERE N_SEGMENT='&NumSegment'
	AND TYPE_P='&TypeLogiciel';
	IF NB=0 THEN
		RAISE TYPE_POSTE_LOG_ERREUR;
	END IF;

	NUM_UDP:=2;
	
	FOR CURSEURPOSTE_REC IN CURSEURPOSTE LOOP
		INSERT INTO INSTALLER VALUES
		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
		
		UPDATE POSTE SET NB_LOG = NB_LOG + 1 WHERE CURSEURPOSTE_REC.N_POSTE = POSTE.N_POSTE;
		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
				
		MESSAGE := 'Installation sur le '||CURSEURPOSTE_REC.NOM_P||' dans la salle '||CURSEURPOSTE_REC.NOM_S;	
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	END LOOP;
	
	MESSAGE := 'Transaction reussie !';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	
	COMMIT;
EXCEPTION
	WHEN DUP_VAL_ON_INDEX THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
	WHEN NO_DATA_FOUND THEN
		ROLLBACK;
		IF NUM_UDP=1 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Numero de segment inconnu.');		
		ELSIF NUM_UDP=2 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Type de poste inconnu.');
		END IF;
	WHEN FK_TYPE_LOG THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Type de logiciel inconnu.');
	WHEN NOT_NULL_ERREUR THEN
		ROLLBACK;
		IF NUM_UDP=1 THEN		
			INSERT INTO COMPTE_RENDU VALUES ('Valeur nulle non permise dans LOGICIEL');
		ELSIF NUM_UDP=2 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Valeur nulle non permise dans INSTALLER');
		END IF;
	WHEN DATE_ACHAT_ERREUR THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Date d''achat du logiciel superieure a la date du jour.');		
	WHEN TYPE_POSTE_LOG_ERREUR THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Aucune installation possible sur ce segment: pas de poste de ce type.');			
	WHEN OTHERS THEN
		ROLLBACK;
		MESSAGE:=SUBSTR(SQLERRM,1,80);
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);		
END;
/
-- fin du bloc PL/SQL
-- REMARQUE : les 2 UPDATE realises devraient normalement etre inutiles car des triggers
-- sont en theorie prevus pour ce traitement (TP6)
-- mise au point du bloc
SHOW ERRORS;
SELECT * FROM COMPTE_RENDU;
--SPOOL OFF;
