-- 2
SET PAGESIZE 30;
PROMPT 'Fichier sortie :'
ACCEPT ficsortie
SPOOL &ficsortie.sql;

-- cration de la table COMPTE_RENDU (sans contraintes)
DROP TABLE COMPTE_RENDU;
CREATE TABLE COMPTE_RENDU
(
	LIGNE_COMPTE_RENDU VARCHAR(80)
);

PROMPT 'Entrez le numro du poste :'
ACCEPT NumPoste

PROMPT 'Entrez le nom du poste :'
ACCEPT NomPoste

PROMPT 'Entrez le numero du segment :'
ACCEPT NumSegment

PROMPT 'Entrez l adresse :'
ACCEPT AdressePoste

PROMPT 'Entrez le type du poste :'
ACCEPT TypePoste

PROMPT 'Entrez le numero de la salle :'
ACCEPT NumSalle

-- dbut du bloc PL/SQL
DECLARE	
	ENF_SANS_PARENT EXCEPTION;
	PRAGMA EXCEPTION_INIT(ENF_SANS_PARENT,-2291);
	ADRESSE_IP_ERREUR EXCEPTION;
	MESSAGE COMPTE_RENDU.LIGNE_COMPTE_RENDU%TYPE;	
	NB INTEGER;
	NumSeg SEGMENT.N_SEGMENT%TYPE;
BEGIN	
	SELECT COUNT(*) INTO NB  
	FROM POSTE WHERE
	N_SEGMENT = '&NumSegment'
	AND AD = '&AdressePoste';
	IF NB > 0 THEN
		RAISE ADRESSE_IP_ERREUR; 
	END IF;	

	INSERT INTO POSTE VALUES
	('&NumPoste','&NomPoste','&NumSegment','&AdressePoste','&TypePoste','&NumSalle',0);	
	MESSAGE:='Enregistrement du &NomPoste dans POSTE';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	
	MESSAGE:='Transaction reussie';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 
	COMMIT;
		
EXCEPTION
	WHEN DUP_VAL_ON_INDEX THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU 
		VALUES('Le &NomPoste est deja present.');
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 
	WHEN ADRESSE_IP_ERREUR THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU
		VALUES ('Adresse IP est deja utilisee.');
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 	
	WHEN ENF_SANS_PARENT THEN
		ROLLBACK;
		IF SQLERRM LIKE '%FK_POSTE_SALLE%' THEN
			MESSAGE:='Salle inconnue';
			INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		ELSIF SQLERRM LIKE '%FK_POSTE_SEGMENT%' THEN
			MESSAGE:='Segment inconnu';
			INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		ELSIF SQLERRM LIKE '%FK_POSTE_TYPE%' THEN
			MESSAGE:='Type de poste inconnu';
			INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		END IF;	
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 
	WHEN OTHERS THEN
		ROLLBACK;
		MESSAGE:=SUBSTR(SQLERRM,1,80);
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 		
END;
/
-- fin du bloc PL/SQL
-- REMARQUE : les 2 UPDATE realises devraient normalement etre inutiles car des triggers
-- sont en theorie prevus pour ce traitement (TP6)
-- mise au point du bloc
-- SHOW ERRORS;
SELECT * FROM COMPTE_RENDU;
SPOOL OFF;
