-- implementation du package
CREATE OR REPLACE PACKAGE BODY Park_info AS


-- Procedure d'installation de logiciel
PROCEDURE Install_log(pNumSegment SEGMENT.N_SEGMENT%TYPE,pNumLogiciel LOGICIEL.N_LOG%TYPE,pNomLogiciel LOGICIEL.NOM_L%TYPE,pDateAchatLogiciel LOGICIEL.DATE_ACH%TYPE,pVersionLogiciel LOGICIEL.VERSION%TYPE,pTypeLogiciel LOGICIEL.TYPE_L%TYPE) IS


	 
	CURSOR CURSEURPOSTE IS 	 
	SELECT N_POSTE, NOM_P, NOM_S 
	FROM POSTE, SALLE 
	WHERE POSTE.N_SEGMENT = pNumSegment
	AND TYPE_P = pTypeLogiciel
	AND POSTE.N_SALLE = SALLE.N_SALLE; 
	MESSAGE COMPTE_RENDU.LIGNE_COMPTE_RENDU%TYPE; 
	FK_TYPE_LOG EXCEPTION; 
	PRAGMA EXCEPTION_INIT(FK_TYPE_LOG,-2291); 
	NOT_NULL_ERREUR EXCEPTION; 
	TYPE_POSTE_LOG_ERREUR EXCEPTION;
	DATE_ACHAT_ERREUR EXCEPTION; 
	NO_DATA_FOUND EXCEPTION;
	PRAGMA EXCEPTION_INIT(NO_DATA_FOUND,+100);
	NUM_UDP INTEGER; 
	NB INTEGER;
	NumSeg SEGMENT.N_SEGMENT%TYPE;
BEGIN	 
	NUM_UDP := 1;
	
	SELECT N_SEGMENT INTO NumSeg FROM SEGMENT 
	WHERE N_SEGMENT=pNumSegment;
	
	IF pDateAchatLogiciel > SYSDATE THEN
		RAISE DATE_ACHAT_ERREUR;
	END IF;
		
	INSERT INTO LOGICIEL VALUES 
	(pNumLogiciel,pNomLogiciel,pDateAchatLogiciel,pVersionLogiciel,pTypeLogiciel,0);

	MESSAGE := 'Enregistrement du logiciel '|| ' pNomLogiciel dans LOGICIEL';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	
	SELECT COUNT(*) INTO NB FROM POSTE 
	WHERE N_SEGMENT=pNumSegment
	AND TYPE_P=pTypeLogiciel;
	IF NB=0 THEN
		RAISE TYPE_POSTE_LOG_ERREUR;
	END IF;
 
	NUM_UDP:=2;
	
	FOR CURSEURPOSTE_REC IN CURSEURPOSTE LOOP 
		INSERT INTO INSTALLER VALUES 
		(CURSEURPOSTE_REC.N_POSTE,pNumLogiciel,SYSDATE); 
		 
		UPDATE POSTE SET NB_LOG = NB_LOG + 1 WHERE CURSEURPOSTE_REC.N_POSTE = POSTE.N_POSTE; 
		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE pNumLogiciel = N_LOG; 
				 
		MESSAGE := 'Installation sur le '||CURSEURPOSTE_REC.NOM_P||' dans la salle '||CURSEURPOSTE_REC.NOM_S;	 
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE); 
	END LOOP; 
	
	MESSAGE := 'Transaction reussie !'; 
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE); 
	

	COMMIT; 

EXCEPTION 
	WHEN DUP_VAL_ON_INDEX THEN 
		ROLLBACK; 
		INSERT INTO COMPTE_RENDU VALUES ('Le '||pNumLogiciel|| 'est deja prsent dans LOGICIEL.'); 
	WHEN NO_DATA_FOUND THEN
		ROLLBACK;
		IF NUM_UDP=1 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Numero de segment inconnu.');		
		ELSIF NUM_UDP=2 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Type de poste inconnu.');
		END IF;
	WHEN FK_TYPE_LOG THEN 
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Type de logiciel inconnu.');
	WHEN NOT_NULL_ERREUR THEN 
		ROLLBACK; 
		IF NUM_UDP=1 THEN		
			INSERT INTO COMPTE_RENDU VALUES ('Valeur nulle non permise dans LOGICIEL'); 
		ELSIF NUM_UDP=2 THEN
			INSERT INTO COMPTE_RENDU VALUES ('Valeur nulle non permise dans INSTALLER');
		END IF;
	WHEN DATE_ACHAT_ERREUR THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Date d''achat du logiciel superieure a la date du jour.');		
	WHEN TYPE_POSTE_LOG_ERREUR THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU VALUES ('Aucune installation possible sur ce segment: pas de poste de ce type.');			
	WHEN OTHERS THEN 
		ROLLBACK; 
		MESSAGE:=SUBSTR(SQLERRM,1,80); 
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);

END Install_log;

-- Fonction privee
FUNCTION Ad_existe(pAdresse POSTE.AD%TYPE,pSegment POSTE.N_SEGMENT%TYPE) RETURN BOOLEAN IS 

RETOUR BOOLEAN;
NB INTEGER;

BEGIN
	SELECT COUNT(*) INTO NB 
	FROM POSTE WHERE
	N_SEGMENT = pSegment
	AND AD = pAdresse;
	IF NB > 0 THEN 
		RETOUR:=TRUE;
	ELSE
		RETOUR:= FALSE;
	END IF;
	
	RETURN(RETOUR);
		
END Ad_existe;

-- Fonction privee
-- renvoie le nombre de postes deja installes dans la salle passee en parametre
FUNCTION Nb_poste(pNumSalle POSTE.N_SALLE%TYPE) RETURN INTEGER IS

RETOUR INTEGER;
NB INTEGER;

BEGIN
	SELECT COUNT(N_POSTE) INTO NB
	FROM POSTE
	WHERE N_SALLE = pNumSalle;
	
	RETURN(RETOUR);
	
END Nb_poste;
 
PROCEDURE Install_poste(pNumPoste POSTE.N_POSTE%TYPE,pNomPoste POSTE.NOM_P%TYPE,pNumSegment POSTE.N_SEGMENT%TYPE,pAdressePoste POSTE.AD%TYPE,pTypePoste POSTE.TYPE_P%TYPE, pNumSalle POSTE.N_SALLE%TYPE) IS

	ENF_SANS_PARENT EXCEPTION; 
	PRAGMA EXCEPTION_INIT(ENF_SANS_PARENT,-2291);
	ADRESSE_IP_ERREUR EXCEPTION;
	MAXIMUM_POSTE_ATTEIND EXCEPTION;
	MESSAGE COMPTE_RENDU.LIGNE_COMPTE_RENDU%TYPE;	
	NumSeg SEGMENT.N_SEGMENT%TYPE;
	NbPoste INTEGER;
BEGIN	 
	
	IF Ad_existe(pAdressePoste,pNumSegment) THEN
		RAISE ADRESSE_IP_ERREUR; 
	END IF;
	IF Nb_poste(pNumSalle)=14 THEN
		RAISE MAXIMUM_POSTE_ATTEIND;
	END IF;
		 	
	INSERT INTO POSTE VALUES
	(pNumPoste,pNomPoste,pNumSegment,pAdressePoste,pTypePoste,pNumSalle,0);	
	MESSAGE:='Enregistrement du '||pNomPoste||' dans POSTE';

	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	MESSAGE:='Transaction reussie';
	INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 
	COMMIT;
		 
EXCEPTION 
	WHEN DUP_VAL_ON_INDEX THEN 
		ROLLBACK;
		INSERT INTO COMPTE_RENDU 
		VALUES('Le '||pNomPoste||' est deja present.');
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 
	WHEN ADRESSE_IP_ERREUR THEN 
		ROLLBACK;
		INSERT INTO COMPTE_RENDU
		VALUES ('Adresse IP est deja utilisee.');
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
	WHEN MAXIMUM_POSTE_ATTEIND THEN
		ROLLBACK;
		INSERT INTO COMPTE_RENDU
		VALUES ('Maximum de postes atteind.');
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	
	WHEN ENF_SANS_PARENT THEN
		ROLLBACK;
		IF SQLERRM LIKE '%FK_POSTE_SALLE%' THEN
			MESSAGE:='Salle inconnue';
			INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		ELSIF SQLERRM LIKE '%FK_POSTE_SEGMENT%' THEN
			MESSAGE:='Segment inconnu';
			INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		ELSIF SQLERRM LIKE '%FK_POSTE_TYPE%' THEN
			MESSAGE:='Type de poste inconnu';
			INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		END IF;	
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 
	WHEN OTHERS THEN 
		ROLLBACK; 
		MESSAGE:=SUBSTR(SQLERRM,1,80); 
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);
		MESSAGE:='Transaction annulee';
		INSERT INTO COMPTE_RENDU VALUES (MESSAGE);	 		 

END Install_poste; 
 
END Park_info;
/

